diff -urN libgnomedb/libgnomedb/gnome-db-basic-form.c libgnomedbnew/libgnomedb/gnome-db-basic-form.c
--- libgnomedb/libgnomedb/gnome-db-basic-form.c	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/gnome-db-basic-form.c	2009-04-19 18:38:14.000000000 +0200
@@ -28,6 +28,8 @@
 #include "utility.h"
 #include "gnome-db-data-entry.h"
 #include <libgnomedb/data-entries/gnome-db-entry-combo.h>
+#include <libgnomedb/gnome-db-data-widget.h>
+#include <libgnomedb/gnome-db-raw-form.h>
 
 static void gnome_db_basic_form_class_init (GnomeDbBasicFormClass * class);
 static void gnome_db_basic_form_init (GnomeDbBasicForm *wid);
@@ -48,7 +50,7 @@
 static void gnome_db_basic_form_clean (GnomeDbBasicForm *form);
 
 static void get_rid_of_set (GdaSet *paramlist, GnomeDbBasicForm *form);
-static void paramlist_public_data_changed_cb (GdaSet *paramlist, GnomeDbBasicForm *form);
+static void paramlist_public_data_changed_cb (GnomeDbSet *paramlist, GnomeDbBasicForm *form);
 static void paramlist_param_attr_changed_cb (GdaSet *paramlist, GdaHolder *param, 
 					     const gchar *att_name, const GValue *att_value, GnomeDbBasicForm *form);
 
@@ -69,6 +71,7 @@
 {
         PROP_0,
 	PROP_LAYOUT_SPEC,
+	PROP_DATA_LAYOUT,
 	PROP_PARAMLIST,
 	PROP_HEADERS_SENSITIVE,
 	PROP_SHOW_ACTIONS,
@@ -78,6 +81,7 @@
 struct _GnomeDbBasicFormPriv
 {
 	GdaSet                 *set;
+	GnomeDbSet             *set_info;
 	gulong                 *signal_ids; /* array of signal ids */
 
 	GSList                 *entries;/* list of GnomeDbDataEntry widgets */
@@ -87,6 +91,7 @@
 	GtkWidget              *entries_table;
 	GtkWidget              *entries_glade;
 	GSList                 *hidden_entries;
+	GtkScrolledWindow      *scrolled_window;  /* Window child. */
 
 	gboolean                headers_sensitive;
 	gboolean                forward_param_updates; /* forward them to the GnomeDbDataEntry widgets ? */
@@ -169,6 +174,10 @@
 					 g_param_spec_pointer ("layout_spec", 
 							       _("Pointer to a GnomeDbFormLayoutSpec structure"), NULL,
 							       G_PARAM_WRITABLE));
+	g_object_class_install_property (object_class, PROP_DATA_LAYOUT,
+					 g_param_spec_pointer ("data_layout", 
+							       _("Pointer to an XML data layout specification"), NULL,
+							       G_PARAM_WRITABLE));
 	g_object_class_install_property (object_class, PROP_PARAMLIST,
 					 g_param_spec_pointer ("paramlist", 
 							       _("List of parameters to show in the form"), NULL,
@@ -301,7 +310,7 @@
 	form->priv->signal_ids = NULL;
 
 	/* unref the paramlist */
-	g_signal_handlers_disconnect_by_func (paramlist,
+	g_signal_handlers_disconnect_by_func (form->priv->set_info,
 					      G_CALLBACK (paramlist_public_data_changed_cb), form);
 	g_signal_handlers_disconnect_by_func (paramlist,
 					      G_CALLBACK (paramlist_param_attr_changed_cb), form);
@@ -309,6 +318,11 @@
 	g_object_unref (form->priv->set);
 	form->priv->set = NULL;
 
+	if (form->priv->set_info) {
+		g_object_unref (form->priv->set_info);
+		form->priv->set_info = NULL;
+	}
+
 	/* render all the entries non sensitive */
 	list = form->priv->entries;
 	while (list) {
@@ -318,7 +332,7 @@
 }
 
 static void
-paramlist_public_data_changed_cb (GdaSet *paramlist, GnomeDbBasicForm *form)
+paramlist_public_data_changed_cb (GnomeDbSet *paramlist, GnomeDbBasicForm *form)
 {
 	/* here we want to re-define all the data entry widgets */
 	gnome_db_basic_form_clean (form);
@@ -369,14 +383,14 @@
 				hidden_params = g_slist_prepend (hidden_params, param);
 			else {
 				/* multiple parameters, take the 1st param */
-				GdaSetGroup *group;				
-				group = g_object_get_data (G_OBJECT (list->data), "group");
-				hidden_params = g_slist_prepend (hidden_params, GDA_SET_NODE (group->nodes->data)->holder);
+				GnomeDbSetGroup *group;
+				group = g_object_get_data (G_OBJECT (list->data), "__gnome_db_group");
+				hidden_params = g_slist_prepend (hidden_params, GDA_SET_NODE (group->group->nodes->data)->holder);
 			}
 		}
 
 		/* re-create entries */
-		paramlist_public_data_changed_cb (paramlist, form);
+		paramlist_public_data_changed_cb (form->priv->set_info, form);
 
 		/* hide entries which were hidden */
 		for (list = hidden_params; list; list = list->next) 
@@ -413,6 +427,759 @@
 }
 
 static void
+load_xml_data_layout_button (GnomeDbBasicForm  *form,
+			     xmlNodePtr         node,
+			     gpointer           data)
+{
+	g_print ("%s:\n", __func__);
+	g_return_if_fail (form && GNOME_DB_IS_BASIC_FORM (form));
+	g_return_if_fail (data && GTK_IS_TABLE(data));
+
+	gchar *title = NULL;
+	gchar *script = NULL;
+	gint sequence = 0;
+
+	xmlChar *str;
+	str = xmlGetProp (node, "title");
+	if (str) {
+		title = g_strdup (str);
+		g_print ("title: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "script");
+	if (str) {
+		script = g_strdup (str);
+		g_print ("script: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "sequence");
+	if (str) {
+		sequence = atoi (str);
+		g_print ("sequence: %s\n", str);
+		xmlFree (str);
+	}
+
+	GtkButton *button = (GtkButton *) gtk_button_new_with_mnemonic (title);
+	gtk_widget_show (GTK_WIDGET(button));
+
+	gint n_columns, n_rows;
+	g_object_get (G_OBJECT(data), "n-columns", &n_columns, NULL);
+	g_object_get (G_OBJECT(data), "n-rows", &n_rows, NULL);
+
+	gint col, row;
+	col = 2 * ((sequence - 1) / n_rows);
+	row = (sequence - 1) % n_rows;
+
+	gtk_table_attach (GTK_TABLE(data), GTK_WIDGET(button),
+			  col, col + 2, row, row + 1,
+			  (GtkAttachOptions) (GTK_FILL|GTK_EXPAND),
+			  (GtkAttachOptions) (GTK_FILL|GTK_EXPAND), 0, 0);
+
+	xmlNodePtr child;
+	for (child = node->children; child != NULL; child = child->next) {
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "script")) {
+			// load_data_layout_button_script (table, child);
+		}
+	}
+}
+
+static void
+load_xml_data_layout_item (GnomeDbBasicForm  *form,
+			   xmlNodePtr         node,
+			   gpointer           data)
+{
+	g_print ("%s:\n", __func__);
+	g_return_if_fail (form && GNOME_DB_IS_BASIC_FORM (form));
+	g_return_if_fail (data && GTK_IS_TABLE(data));
+
+	gchar *name = NULL;
+	gint sequence = 0;
+	gboolean editable = FALSE;
+	gboolean sort_ascending = FALSE;
+
+	xmlChar *str;
+	str = xmlGetProp (node, "name");
+	if (str) {
+		name = g_strdup (str);
+		g_print ("name: %s\n", str);
+		xmlFree (str);
+	}
+
+	/* str = xmlGetProp (node, "relationship"); */
+	/* if (str) { */
+	/* 	g_print ("relationship: %s\n", str); */
+	/* 	xmlFree (str); */
+	/* } */
+
+	/* str = xmlGetProp (node, "related_relationship"); */
+	/* if (str) { */
+	/* 	g_print ("related_relationship: %s\n", str); */
+	/* 	xmlFree (str); */
+	/* } */
+
+	str = xmlGetProp (node, "sequence");
+	if (str) {
+		sequence = atoi (str);
+		g_print ("sequence: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "editable");
+	if (str) {
+		editable = (*str == 't' || *str == 'T') ? TRUE : FALSE;
+		g_print ("editable: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "sort_ascending");
+	if (str) {
+		sort_ascending = (*str == 't' || *str == 'T') ? TRUE : FALSE;
+		g_print ("sort_ascending: %s\n", str);
+		xmlFree (str);
+	}
+
+	/* GSList *slist = form->priv->set->holders; */
+	/* while (slist != NULL) { */
+	/* 	GdaHolder *holder = slist->data; */
+	/* 	g_print ("SET HOLDER=%s\n", gda_holder_get_id (holder)); */
+	/* 	slist = g_slist_next (slist); */
+	/* } */
+
+	gint n_columns, n_rows;
+	g_object_get (G_OBJECT(data), "n-columns", &n_columns, NULL);
+	g_object_get (G_OBJECT(data), "n-rows", &n_rows, NULL);
+
+	gint col, row;
+	col = 2 * ((sequence - 1) / n_rows);
+	row = (sequence - 1) % n_rows;
+
+	GdaHolder *holder = gda_set_get_holder (form->priv->set, name);
+	g_return_if_fail (holder != NULL);
+
+	/* const gchar *id = gda_holder_get_id (holder); */
+
+	/* const gchar *text; */
+	/* const GValue *value = gda_holder_get_attribute (holder, GDA_ATTRIBUTE_DESCRIPTION); */
+	/* if (value != NULL && G_VALUE_HOLDS(value, G_TYPE_STRING)) */
+	/* 	text = g_value_get_string (value); */
+	/* else */
+	/* 	text = id; */
+	const gchar *text = NULL;
+	if (GNOME_DB_IS_RAW_FORM (form)) {
+		GdaDataModel *model = gnome_db_data_widget_get_gda_model (GNOME_DB_DATA_WIDGET (form));
+		if (model && GDA_IS_DATA_SELECT (model))
+			text = gda_utility_data_model_find_column_description (GDA_DATA_SELECT (model), name);
+	}
+	if (! text)
+		text = gda_holder_get_id (holder);
+
+	GtkLabel *label = GTK_LABEL(gtk_label_new (text));
+	gtk_widget_show (GTK_WIDGET(label));
+	gtk_table_attach (GTK_TABLE(data), GTK_WIDGET(label),
+			  col, col + 1, row, row + 1,
+			  (GtkAttachOptions) GTK_FILL,
+			  (GtkAttachOptions) (GTK_FILL|GTK_EXPAND), 0, 0);
+	gtk_misc_set_alignment (GTK_MISC(label), 0, /* 0 */ 0.5);
+
+	GtkAlignment *alignment = GTK_ALIGNMENT(gtk_alignment_new (0.5, 0.5, 1, 1));
+	gtk_widget_show (GTK_WIDGET(alignment));
+	gtk_table_attach (GTK_TABLE(data), GTK_WIDGET(alignment),
+			  col + 1, col + 2, row, row + 1,
+			  (GtkAttachOptions) (GTK_EXPAND|GTK_FILL),
+			  (GtkAttachOptions) (GTK_EXPAND|GTK_FILL), 0, 0);
+	gtk_alignment_set_padding (GTK_ALIGNMENT(alignment), 0, 0, 12, 0);
+
+	GtkHBox *hbox = GTK_HBOX(gtk_hbox_new (FALSE, /* 0 */ 6));
+	gtk_widget_show (GTK_WIDGET(hbox));
+	gtk_container_add (GTK_CONTAINER(alignment), GTK_WIDGET(hbox));
+
+	// name hbox (both name and id are equals)
+	gtk_widget_set_name (GTK_WIDGET(hbox), name);
+
+	g_free (name);
+
+	xmlNodePtr child;
+	for (child = node->children; child != NULL; child = child->next) {
+
+		/* if (child->type == XML_ELEMENT_NODE && */
+		/*     !xmlStrcmp (child->name, (const xmlChar *) "formatting")) { */
+		/* } */
+
+		/* if (child->type == XML_ELEMENT_NODE && */
+		/*     !xmlStrcmp (child->name, (const xmlChar *) "title_custom")) { */
+		/* } */
+	}
+}
+
+static gint
+count_items (xmlNodePtr  node)
+{
+	gint n = 0;
+
+	g_return_val_if_fail (node->type == XML_ELEMENT_NODE &&
+			      (!xmlStrcmp (node->name, (const xmlChar *) "data_layout_group") ||
+			       !xmlStrcmp (node->name, (const xmlChar *) "data_layout_portal") ||
+			       !xmlStrcmp (node->name, (const xmlChar *) "data_layout_notebook")), -1);
+
+	if (node->children) {
+		xmlNodePtr child;
+		child = node->children;
+		while (child) {
+			if (child->type == XML_ELEMENT_NODE &&
+			    (!xmlStrcmp (child->name, (const xmlChar *) "data_layout_group") ||
+			     !xmlStrcmp (child->name, (const xmlChar *) "data_layout_item") ||
+			     !xmlStrcmp (child->name, (const xmlChar *) "data_layout_portal") ||
+			     !xmlStrcmp (node->name, (const xmlChar *) "data_layout_notebook") ||
+			     !xmlStrcmp (child->name, (const xmlChar *) "data_layout_button"))) {
+				n++;
+			}
+			child = child->next;
+		}
+	}
+
+	return n;
+}
+
+static void
+load_xml_data_layout_portal (GnomeDbBasicForm  *form,
+			     xmlNodePtr         node,
+			     gpointer           data)
+{
+	g_return_if_fail (form && GNOME_DB_IS_BASIC_FORM (form));
+
+	gchar *name = NULL;
+	gchar *relationship = NULL;
+	gint sequence = 0;
+	gboolean hidden = FALSE;
+	gint columns_count = 1;
+
+	xmlChar *str;
+	str = xmlGetProp (node, "name");
+	if (str) {
+		name = g_strdup (str);
+		g_print ("name: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "relationship");
+	if (str) {
+		relationship = g_strdup (str);
+		g_print ("relationship: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "sequence");
+	if (str) {
+		sequence = atoi (str);
+		g_print ("sequence: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "hidden");
+	if (str) {
+		hidden = *str == 't' || *str == 'T' ? TRUE : FALSE;
+		g_print ("hidden: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "columns_count");
+	if (str) {
+		columns_count = atoi (str);
+		g_print ("columns_count: %s\n", str);
+		xmlFree (str);
+	}
+
+	GtkWidget *vbox;
+	vbox = gtk_vbox_new (FALSE, 0);
+	gtk_widget_show (vbox);
+
+	gint n_columns, n_rows;
+	g_object_get (G_OBJECT(data), "n-columns", &n_columns, NULL);
+	g_object_get (G_OBJECT(data), "n-rows", &n_rows, NULL);
+
+	gint col, row;
+	col = 2 * ((sequence - 1) / n_rows);
+	row = (sequence - 1) % n_rows;
+
+	gtk_table_attach (GTK_TABLE (data), vbox,
+			  col, col + 2, row, row + 1,
+			  (GtkAttachOptions) (GTK_FILL|GTK_EXPAND),
+			  (GtkAttachOptions) (GTK_FILL|GTK_EXPAND), 0, 0);
+
+	gtk_widget_set_name (vbox, name);
+
+	if (!xmlStrcmp (node->parent->name, (const xmlChar *) "data_layout_group")) {
+
+
+		gint n_columns, n_rows;
+		g_object_get (G_OBJECT(data), "n-columns", &n_columns, NULL);
+		g_object_get (G_OBJECT(data), "n-rows", &n_rows, NULL);
+
+		gint col, row;
+		col = 2 * ((sequence - 1) / n_rows);
+		row = (sequence - 1) % n_rows;
+
+		gtk_table_attach (GTK_TABLE(data), GTK_WIDGET(vbox),
+				  col, col + 2, row, row + 1,
+				  (GtkAttachOptions) (GTK_FILL|GTK_EXPAND),
+				  (GtkAttachOptions) (GTK_FILL|GTK_EXPAND), 0, 0);
+	} else
+	if (!xmlStrcmp (node->parent->name, (const xmlChar *) "data_layout_notebook")) {
+
+		GtkLabel *label;
+		gchar *markup = g_strdup_printf ("<b>%s</b>", (name != NULL) ? name : "");
+		label = GTK_LABEL(gtk_label_new (markup));
+		g_free (markup);
+		gtk_widget_show (GTK_WIDGET(label));
+		gtk_label_set_use_markup (label, TRUE);
+
+		gtk_container_add (GTK_CONTAINER(data), GTK_WIDGET(vbox));
+
+		gtk_notebook_set_tab_label (GTK_NOTEBOOK(data),
+					    gtk_notebook_get_nth_page
+					    (GTK_NOTEBOOK(data), sequence - 1),
+					    GTK_WIDGET(label));
+	}
+
+	g_free (name);
+	g_free (relationship);
+}
+
+static void
+load_xml_data_layout_group (GnomeDbBasicForm  *form,
+			    xmlNodePtr         node,
+			    gpointer           data);
+
+static void
+load_xml_data_layout_notebook (GnomeDbBasicForm  *form,
+			       xmlNodePtr         node,
+			       gpointer           data)
+{
+	g_return_if_fail (form && GNOME_DB_IS_BASIC_FORM (form));
+
+	gchar *name = NULL;
+	gint sequence = 0;
+	gchar *title = NULL;
+
+	xmlChar *str;
+	str = xmlGetProp (node, "name");
+	if (str) {
+		g_print ("name: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "title");
+	if (str) {
+		g_print ("title: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "sequence");
+	if (str) {
+		sequence = atoi (str);
+		g_print ("sequence: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "columns_count");
+	if (str) {
+		g_print ("columns_count: %s\n", str);
+		xmlFree (str);
+	}
+
+	/* GtkLabel *label; */
+	/* gchar *markup = g_strdup_printf ("<b>%s</b>", (title != NULL) ? title : ""); */
+	/* label = GTK_LABEL(gtk_label_new (markup)); */
+	/* g_free (markup); */
+	/* gtk_widget_show (GTK_WIDGET(label)); */
+	/* gtk_label_set_use_markup (label, TRUE); */
+
+	GtkWidget *notebook;
+	notebook = gtk_notebook_new ();
+	gtk_widget_show (notebook);
+
+	gint n_columns, n_rows;
+	g_object_get (G_OBJECT(data), "n-columns", &n_columns, NULL);
+	g_object_get (G_OBJECT(data), "n-rows", &n_rows, NULL);
+
+	gint col, row;
+	col = 2 * ((sequence - 1) / n_rows);
+	row = (sequence - 1) % n_rows;
+
+	gtk_table_attach (GTK_TABLE(data), notebook,
+			  col, col + 2, row, row + 1,
+			  (GtkAttachOptions) (GTK_FILL|GTK_EXPAND),
+			  (GtkAttachOptions) (GTK_FILL|GTK_EXPAND), 0, 0);
+
+	xmlNodePtr child;
+	for (child = node->children; child != NULL; child = child->next) {
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_group")) {
+			load_xml_data_layout_group (form, child, /* data */ notebook);
+		}
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_portal")) {
+			load_xml_data_layout_portal (form, child, /* data */ notebook);
+		}
+	}
+
+	g_free (name);
+	g_free (title);
+}
+
+static void
+load_xml_data_layout_group (GnomeDbBasicForm  *form,
+			    xmlNodePtr         node,
+			    gpointer           data)
+{
+	g_print ("%s:\n", __func__);
+	g_return_if_fail (form && GNOME_DB_IS_BASIC_FORM (form));
+	g_return_if_fail (form->priv->scrolled_window != NULL);
+
+	gchar *name = NULL;
+	gint sequence = 0;
+	gint columns_count = 1;
+	gchar *title = NULL;
+
+	xmlChar *str;
+	str = xmlGetProp (node, "name");
+	if (str) {
+		name = g_strdup (str);
+		g_print ("name: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "sequence");
+	if (str) {
+		sequence = atoi (str);
+		g_print ("sequence: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "columns_count");
+	if (str) {
+		columns_count = atoi (str);
+		g_print ("columns_count: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "title");
+	if (str) {
+		title = g_strdup (str);
+		g_print ("title: %s\n", str);
+		xmlFree (str);
+	}
+
+	GtkLabel *label;
+	label = GTK_LABEL(gtk_label_new (NULL));
+	gtk_widget_show (GTK_WIDGET(label));
+
+	gint n = count_items (node);
+
+	gint cols, rows;
+	cols = 2 * columns_count;
+	rows = n / columns_count + n % columns_count;
+
+	GtkTable *table;
+	table = GTK_TABLE(gtk_table_new (rows, cols, FALSE));
+	gtk_widget_show (GTK_WIDGET(table));
+
+	gtk_container_set_border_width (GTK_CONTAINER(table), 6);
+	gtk_table_set_row_spacings (table, 3);
+	gtk_table_set_col_spacings (table, 3);
+
+	if (!xmlStrcmp (node->parent->name, (const xmlChar *) "data_layout_groups")) {
+
+		GtkFrame *frame = GTK_FRAME(gtk_frame_new (NULL));
+		gtk_widget_show (GTK_WIDGET(frame));
+		gtk_frame_set_shadow_type (frame, GTK_SHADOW_NONE);
+
+		GtkAlignment *alignment = GTK_ALIGNMENT(gtk_alignment_new (0.5, 0.5, 1, 1));
+		gtk_widget_show (GTK_WIDGET(alignment));
+		gtk_container_add (GTK_CONTAINER(frame), GTK_WIDGET(alignment));
+		gtk_alignment_set_padding (alignment, 0, 0, 12, 0);
+
+		gtk_container_add (GTK_CONTAINER(alignment), GTK_WIDGET(table));
+
+		gchar *markup = g_strdup_printf ("<b>%s</b>", (title != NULL) ? title : "");
+		gtk_label_set_text (label, markup);
+		g_free (markup);
+		gtk_label_set_use_markup (label, TRUE);
+
+		gtk_frame_set_label_widget (frame, GTK_WIDGET(label));
+
+
+		gtk_box_pack_start (GTK_BOX(data), GTK_WIDGET(frame), FALSE, TRUE, 0);
+	} else
+	if (!xmlStrcmp (node->parent->name, (const xmlChar *) "data_layout_group")) {
+
+		GtkFrame *frame = GTK_FRAME(gtk_frame_new (NULL));
+		gtk_widget_show (GTK_WIDGET(frame));
+		gtk_frame_set_shadow_type (frame, GTK_SHADOW_NONE);
+
+		GtkAlignment *alignment = GTK_ALIGNMENT(gtk_alignment_new (0.5, 0.5, 1, 1));
+		gtk_widget_show (GTK_WIDGET(alignment));
+		gtk_container_add (GTK_CONTAINER(frame), GTK_WIDGET(alignment));
+		gtk_alignment_set_padding (alignment, 0, 0, 12, 0);
+
+		gtk_container_add (GTK_CONTAINER(alignment), GTK_WIDGET(table));
+
+		gchar *markup = g_strdup_printf ("<b>%s</b>", (title != NULL) ? title : "");
+		gtk_label_set_text (label, markup);
+		g_free (markup);
+		gtk_label_set_use_markup (label, TRUE);
+
+		gtk_frame_set_label_widget (frame, GTK_WIDGET(label));
+
+
+		gint n_columns, n_rows;
+		g_object_get (G_OBJECT(data), "n-columns", &n_columns, NULL);
+		g_object_get (G_OBJECT(data), "n-rows", &n_rows, NULL);
+
+		gint col, row;
+		col = 2 * ((sequence - 1) / n_rows);
+		row = (sequence - 1) % n_rows;
+
+		gtk_table_attach (GTK_TABLE(data), GTK_WIDGET(frame),
+				  col, col + 2, row, row + 1,
+				  (GtkAttachOptions) (GTK_FILL|GTK_EXPAND),
+				  (GtkAttachOptions) (GTK_FILL|GTK_EXPAND), 0, 0);
+	} else
+	if (!xmlStrcmp (node->parent->name, (const xmlChar *) "data_layout_notebook")) {
+
+		gchar *text = g_strdup ((title != NULL) ? title : "");
+		gtk_label_set_text (label, text);
+		g_free (text);
+
+		gtk_container_add (GTK_CONTAINER(data), GTK_WIDGET(table));
+
+		gtk_notebook_set_tab_label (GTK_NOTEBOOK(data),
+					    gtk_notebook_get_nth_page
+					    (GTK_NOTEBOOK(data), sequence - 1),
+					    GTK_WIDGET(label));
+	}
+
+	xmlNodePtr child;
+	for (child = node->children; child != NULL; child = child->next) {
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_group")) {
+			load_xml_data_layout_group (form, child, /* data */ table);
+		}
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_item")) {
+			load_xml_data_layout_item (form, child, /* data */ table);
+		}
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_portal")) {
+			load_xml_data_layout_portal (form, child, /* data */ table);
+		}
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_notebook")) {
+			load_xml_data_layout_notebook (form, child, /* data */ table);
+		}
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "trans_set")) {
+			/* load_data_layout_group_trans_set (form, child, data); */
+		}
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_button")) {
+			load_xml_data_layout_button (form, child, /* data */ table);
+		}
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_item_groupby")) {
+		}
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_item_header")) {
+		}
+	}
+
+	g_free (name);
+	g_free (title);
+}
+
+static void
+load_xml_data_layout_groups (GnomeDbBasicForm  *form,
+			     xmlNodePtr         node,
+			     gpointer           data)
+{
+	g_print ("%s:\n", __func__);
+	g_return_if_fail (form && GNOME_DB_IS_BASIC_FORM (form));
+	g_return_if_fail (form->priv->scrolled_window == NULL);
+
+	form->priv->scrolled_window = GTK_SCROLLED_WINDOW
+		(gtk_scrolled_window_new (NULL, NULL));
+	gtk_scrolled_window_set_policy (form->priv->scrolled_window,
+					GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
+	gtk_container_border_width (GTK_CONTAINER(form->priv->scrolled_window), 6);
+	gtk_widget_show (GTK_WIDGET(form->priv->scrolled_window));
+
+	GtkVBox *vbox = GTK_VBOX(gtk_vbox_new (FALSE, 0));
+	gtk_widget_show (GTK_WIDGET(vbox));
+
+	gtk_scrolled_window_add_with_viewport (form->priv->scrolled_window,
+					       (GtkWidget *) vbox);
+	/* gtk_box_pack_start (GTK_BOX(form), (GtkWidget *) form->priv->scrolled_window, */
+	/* 		    TRUE, TRUE, 0); */
+
+	xmlNodePtr child;
+	for (child = node->children; child != NULL; child = child->next) {
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_group")) {
+			load_xml_data_layout_group (form, child, /* data */ vbox);
+		}
+	}
+
+}
+
+static void
+load_xml_data_layout (GnomeDbBasicForm  *form,
+		      xmlNodePtr         node,
+		      gpointer           data)
+{
+	g_print ("%s:\n", __func__);
+	g_return_if_fail (form && GNOME_DB_IS_BASIC_FORM (form));
+
+	gchar *parent_table = NULL;
+	gchar *name = NULL;
+
+	xmlChar *str;
+	str = xmlGetProp (node, "parent_table");
+	if (str) {
+		parent_table = g_strdup (str);
+		g_print ("parent_table: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "name");
+	if (str) {
+		name = g_strdup (str);
+		g_print ("name: %s\n", str);
+		xmlFree (str);
+	}
+
+	// Don't recurse unnecessarily
+	gboolean retval = FALSE;
+	if (strcmp ((const gchar *) data, parent_table) != 0 ||
+	    strcmp ("details", name) != 0) {
+		retval = TRUE;
+	}
+	g_free (parent_table);
+	g_free (name);
+	if (retval)
+		return;
+
+	xmlNodePtr child;
+	for (child = node->children; child != NULL; child = child->next) {
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_groups")) {
+			load_xml_data_layout_groups (form, child, data);
+		}
+	}
+
+}
+
+static void
+load_xml_data_layouts (GnomeDbBasicForm  *form,
+		       xmlNodePtr         node,
+		       gpointer           data)
+{
+	g_print ("%s:\n", __func__);
+	g_return_if_fail (form && GNOME_DB_IS_BASIC_FORM (form));
+
+	xmlNodePtr child;
+	for (child = node->children; child != NULL; child = child->next) {
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout")) {
+			load_xml_data_layout (form, child, data);
+		}
+	}
+}
+
+/* static void */
+/* load_xml_table (GnomeDbBasicForm  *form, */
+/* 		xmlNodePtr         node, */
+/* 		gpointer           data) */
+/* { */
+/* 	g_print ("%s:\n", __func__); */
+
+/* 	xmlChar *str; */
+/* 	str = xmlGetProp (node, "name"); */
+/* 	if (str) { */
+/* 		g_print ("name: %s\n", str); */
+/* 		xmlFree (str); */
+/* 	} */
+
+/* 	/\* str = xmlGetProp (node, "title"); *\/ */
+/* 	/\* if (str) { *\/ */
+/* 	/\* 	g_print ("title: %s\n", str); *\/ */
+/* 	/\* 	xmlFree (str); *\/ */
+/* 	/\* } *\/ */
+
+/* 	/\* str = xmlGetProp (node, "hidden"); *\/ */
+/* 	/\* if (str) { *\/ */
+/* 	/\* 	g_print ("hidden: %s\n", str); *\/ */
+/* 	/\* 	xmlFree (str); *\/ */
+/* 	/\* } *\/ */
+
+/* 	/\* str = xmlGetProp (node, "default"); *\/ */
+/* 	/\* if (str) { *\/ */
+/* 	/\* 	g_print ("default: %s\n", str); *\/ */
+/* 	/\* 	xmlFree (str); *\/ */
+/* 	/\* } *\/ */
+
+/* 	xmlNodePtr child; */
+/* 	for (child = node->children; child != NULL; child = child->next) { */
+
+/* 		/\* if (child->type == XML_ELEMENT_NODE && *\/ */
+/* 		/\*     !xmlStrcmp (child->name, (const xmlChar *) "fields")) { *\/ */
+
+/* 		/\* 	load_xml_fields (table, child, data); *\/ */
+/* 		/\* } *\/ */
+
+/* 		/\* if (child->type == XML_ELEMENT_NODE && *\/ */
+/* 		/\*     !xmlStrcmp (child->name, (const xmlChar *) "relationships")) { *\/ */
+
+/* 		/\* 	load_xml_relationships (table, child, data); *\/ */
+/* 		/\* } *\/ */
+
+/* 		if (child->type == XML_ELEMENT_NODE && */
+/* 		    !xmlStrcmp (child->name, (const xmlChar *) "data_layouts")) { */
+
+/* 			load_xml_data_layouts (form, child, data); */
+/* 		} */
+
+/* 		/\* if (child->type == XML_ELEMENT_NODE && *\/ */
+/* 		/\*     !xmlStrcmp (child->name, (const xmlChar *) "reports")) { *\/ */
+
+/* 		/\* 	load_xml_reports (table, child, data); *\/ */
+/* 		/\* } *\/ */
+
+/* 		/\* if (child->type == XML_ELEMENT_NODE && *\/ */
+/* 		/\*     !xmlStrcmp (child->name, (const xmlChar *) "trans_set")) { *\/ */
+
+/* 		/\* 	load_xml_table_trans_set (table, child, data); *\/ */
+/* 		/\* } *\/ */
+/* 	} */
+
+/* } */
+
+static void
 gnome_db_basic_form_set_property (GObject *object,
 				  guint param_id,
 				  const GValue *value,
@@ -467,6 +1234,28 @@
 			g_warning (_("Libglade support not built."));
 #endif
 			break;
+		case PROP_DATA_LAYOUT:
+			{
+				xmlNodePtr node = g_value_get_pointer (value);
+
+				gnome_db_basic_form_clean (form);
+
+				xmlNodePtr child;
+				for (child = node->children; child != NULL; child = child->next) {
+
+					if (child->type == XML_ELEMENT_NODE &&
+					    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_groups")) {
+						load_xml_data_layout_groups (form, child, NULL);
+					}
+				}
+
+				if (form->priv->scrolled_window != NULL) {
+					g_print ("Loaded XML file, reinit interface\n");
+				}
+				gnome_db_basic_form_fill (form);
+	
+			}
+			break;
 		case PROP_PARAMLIST:
 			if (form->priv->set) {
 #ifdef HAVE_LIBGLADE
@@ -516,7 +1305,9 @@
 				g_return_if_fail (GDA_IS_SET (form->priv->set));
 								
 				g_object_ref (form->priv->set);
-				g_signal_connect (form->priv->set, "public_data_changed",
+				form->priv->set_info = gnome_db_set_new (GDA_SET (form->priv->set));
+
+				g_signal_connect (form->priv->set_info, "public_data_changed",
 						  G_CALLBACK (paramlist_public_data_changed_cb), form);
 				g_signal_connect (form->priv->set, "holder-attr-changed",
 						  G_CALLBACK (paramlist_param_attr_changed_cb), form);
@@ -582,13 +1373,10 @@
 	gint i = 0;
 
 	if (form->priv->set) {
-		list = form->priv->set->holders;
-		while (list) {
+		for (i = 0, list = form->priv->set->holders; 
+		     list; 
+		     i++, list = list->next)
 			g_signal_handler_disconnect (G_OBJECT (list->data), form->priv->signal_ids[i]);
-			
-			list = g_slist_next (list);
-			i++;
-		}
 		g_free (form->priv->signal_ids);
 		form->priv->signal_ids = NULL;
 	}
@@ -616,6 +1404,11 @@
 
 	g_slist_free (form->priv->hidden_entries);
 	form->priv->hidden_entries = NULL;
+
+	if (form->priv->scrolled_window) {
+		gtk_widget_destroy (GTK_WIDGET(form->priv->scrolled_window));
+		form->priv->scrolled_window = NULL;
+	}
 }
 
 static void
@@ -634,6 +1427,23 @@
 static void entry_destroyed_cb (GtkWidget *entry, GnomeDbBasicForm *form);
 static void label_destroyed_cb (GtkWidget *label, GnomeDbBasicForm *form);
 
+static GtkCallback
+find_hbox (GtkWidget  *widget,
+	   gpointer    data)
+{
+	gpointer *d = data;
+
+	if (GTK_IS_CONTAINER(widget)) {
+		const gchar *name = gtk_widget_get_name (widget);
+		if (GTK_IS_HBOX(widget) &&
+		    strcmp (name, (gchar *) *d) == 0)
+			*(++d) = widget;
+		else
+			gtk_container_foreach (GTK_CONTAINER(widget),
+					       (GtkCallback) find_hbox, data);
+	}
+}
+
 /*
  * create the entries in the widget
  */
@@ -645,7 +1455,7 @@
 	gboolean form_expand = FALSE;
 	
 	/* parameters list management */
-	if (!form->priv->set || !form->priv->set->groups_list)
+	if (!form->priv->set || !form->priv->set_info->groups_list)
 		/* nothing to do */
 		return;
 
@@ -654,13 +1464,12 @@
 	i = 0;
 
 	/* creating all the data entries, and putting them into the form->priv->entries list */
-	list = form->priv->set->groups_list;
-	while (list) {
-		GdaSetGroup *group;
+	for (list = form->priv->set_info->groups_list; list; list = list->next) {
+		GnomeDbSetGroup *group;
 		GtkWidget *entry = NULL;
 
-		group = GDA_SET_GROUP (list->data);
-		if (! group->nodes_source) { 
+		group = GNOME_DB_SET_GROUP (list->data);
+		if (! group->group->nodes_source) { 
 			/* there is only one non-constrained parameter */
 			GdaHolder *param;
 			GType type;
@@ -669,9 +1478,9 @@
 			const gchar *plugin = NULL;
 			const GValue *plugin_val;
 
-			g_assert (g_slist_length (group->nodes) == 1);
+			g_assert (g_slist_length (group->group->nodes) == 1);
 
-			param = GDA_HOLDER (GDA_SET_NODE (group->nodes->data)->holder);
+			param = GDA_HOLDER (GDA_SET_NODE (group->group->nodes->data)->holder);
 
 			val = gda_holder_get_value (param);
 			default_val = gda_holder_get_default_value (param);
@@ -730,14 +1539,14 @@
 			GSList *plist;
 			gboolean nnul = TRUE;
 
-			entry = gnome_db_entry_combo_new (form->priv->set, group->nodes_source);
-			g_object_set_data (G_OBJECT (entry), "group", group);
+			entry = gnome_db_entry_combo_new (form->priv->set_info, group->source);
+			g_object_set_data (G_OBJECT (entry), "__gnome_db_group", group);
 			g_object_set_data (G_OBJECT (entry), "form", form);
 			form->priv->entries = g_slist_append (form->priv->entries, entry);
 			g_signal_connect (entry, "destroy", G_CALLBACK (entry_destroyed_cb), form);
 
 			/* connect to the parameter's changes */
-			for (plist = group->nodes; plist; plist = plist->next) {
+			for (plist = group->group->nodes; plist; plist = plist->next) {
 				GdaHolder *param;
 
 				param = GDA_SET_NODE (plist->data)->holder;
@@ -758,7 +1567,6 @@
 				  G_CALLBACK (entry_contents_modified), form);
 		g_signal_connect (G_OBJECT (entry), "contents_activated",
 				  G_CALLBACK (entry_contents_activated), form);
-		list = g_slist_next (list);
 	}
 
 
